//=============================================================================
// TCOSpawnNotify.
// Description: Server and client have both their own version.
//					Checks every actor in the map against the lists, if all the checks
//					pass then tell the mutator to give it an overlay.
//					(See TCOMutator's notes)
// 
// Date: 2021
// ©copyright Francesco Biscazzo. All rights reserved.
//=============================================================================
class TCOSpawnNotify extends SpawnNotify;

var TCOMutator mut;

// Emptied to receive spawnNotification() event after setup() is called, which happens after the map-placed actors are processed.
event postBeginPlay() {
	super(Actor).postBeginPlay();
}

function setup(TCOMutator mut) {
	local SpawnNotify nextSpawnNotify;
	
	self.mut = mut;
	
	for (nextSpawnNotify = level.spawnNotify; nextSpawnNotify != None; nextSpawnNotify = nextSpawnNotify.next)
		if(nextSpawnNotify == self)
			return;
	next = level.spawnNotify;
	level.spawnNotify = self;
}

event Actor spawnNotification(Actor actor) {
	if (!actor.isA('TCOOverlay'))
		// Perform the cheks on properties that don't change over time.
		if ((mut.isSpritedWhitelisted(actor.class) || mut.isMeshedWhitelisted(actor.class)) && !((mut.isSpritedExcluded(actor.class) || mut.isMeshedExcluded(actor.class))))
			//if (mut.baseMoule.canHaveOverlay(actor))
			mut.giveOverlay(actor);
	
	return super.spawnNotification(actor);
}

defaultproperties {
	remoteRole=ROLE_None
	bAlwaysRelevant=False
}
